// group.h	v1.3	8. June 2007	by eddy

/*  lego -- this program generates images of LEGO(R)-like models.

    		Copyright (C) 1998 - 2008 Edmund Nussbaum.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that you will have a lot of 
    fun when using it, but WITHOUT ANY WARRANTY; without even the implied 
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See 
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Please report your experiences, suggestions or whatever related
    to this program to: 

    sibylle.eddy @ t-online.de
    en @ mpifr-bonn.mpg.de 

    or send mail to:
    Edmund Nussbaum, Richard-Wagner-Str. 59, 53115 Bonn, Germany 
*/

#ifndef _GROUP_H
#define _GROUP_H

#include "vector.h"
#include "rotator.h"
#include "room.h"
#include "global.h"
#include "param.h"
#include "shape.h"

class group : public shape		// group of objects
	{
	protected:
	shape** grp_member;
	public:
	group(void) { }
	~group(void);
	void init(param& p,int members);
	void draw(room&);
	};
	
class brick : public group
	{
	public:
	brick(param&);
	};

class ground : public group
	{
	public:
	ground(param&);
	};

class antiroof : public group
	{
	public:
	antiroof(param&);
	};

class roof : public group
	{
	public:
	roof(param&);
	};

class roofcorner : public group
	{
	public:
	roofcorner(param&);
	};

class corner : public group
	{
	public:
	corner(param&);
	};

class round1 : public group
	{
	public:
	round1(param&);
	};

class curved1 : public group
	{
	public:
	curved1(param&);
	};

class curved2 : public group
	{
	public:
	curved2(param&);
	};

class curved5 : public group
	{
	public:
	curved5(param&);
	};

class roundcorner1 : public group
	{
	public:
	roundcorner1(param&);
	};

class roundcorner2 : public group
	{
	public:
	roundcorner2(param&);
	};

class axisvertical : public group
	{
	public:
	axisvertical(param&);
	};
	
class axisone : public group
	{
	public:
	axisone(param&);
	};
	
class axistwo : public group
	{
	public:
	axistwo(param&);
	};
	
class axisfour : public group
	{
	public:
	axisfour(param&);
	};
	
class axisflat : public group
	{
	public:
	axisflat(param&);
	};
	
class rim : public group
	{
	public:
	rim(param&);
	};

class wheel : public group
	{
	public:
	wheel(param&);
	};

class wheelsmall : public group
	{
	public:
	wheelsmall(param&);
	};

class doorleft : public group
	{
	public:
	doorleft(param&);
	};

class doorright : public group
	{
	public:
	doorright(param&);
	};

class turndisk2 : public group
	{
	public:
	turndisk2(param&);
	};

class turndisk4 : public group
	{
	public:
	turndisk4(param&);
	};

class window : public group
	{
	public:
	window(param&);
	};

class wedgeleft : public group
	{
	public:
	wedgeleft(param&);
	};

class wedgeright : public group
	{
	public:
	wedgeright(param&);
	};

class towball : public group
	{
	public:
	towball(param&);
	};

class towsocket : public group
	{
	public:
	towsocket(param&);
	};

class fence1 : public group
	{
	public:
	fence1(param&);
	};

class fence2 : public group
	{
	public:
	fence2(param&);
	};

class test : public group
	{
	public:
	test(param&);
	};

#endif // _GROUP_H
