// line.h	v1.3	22. December 2004	by eddy

/*  lego -- this program generates images of LEGO(R)-like models.

    		Copyright (C) 1998 - 2008 Edmund Nussbaum.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that you will have a lot of 
    fun when using it, but WITHOUT ANY WARRANTY; without even the implied 
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See 
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Please report your experiences, suggestions or whatever related
    to this program to: 

    sibylle.eddy @ t-online.de
    en @ mpifr-bonn.mpg.de 

    or send mail to:
    Edmund Nussbaum, Richard-Wagner-Str. 59, 53115 Bonn, Germany 
*/

#ifndef _LINE_H
#define _LINE_H

#include "global.h"
#include "String.h"
#include <iostream>

class line
	{
	private:
	static const int MAXLL = 128;	// Maximum line length.
	static const int MAXARGS = 9;	// Maximum number of arguments.
	bool moreflag,validflag,keynumflag;
	int lineno,keyn1,keyn2,keyn3,numargs;
	String linearg[MAXARGS];;
	void parsekeynums(void);	// Gets integer numbers in keyword.

	public: 
	line(void);		// Creates line object from stdin.
	~line(void) { }
	bool valid(void) { return validflag; }	// Checks if line is valid.
	bool more(void) { return moreflag; }	// Checks for further lines.
	int linenumber(void) { return lineno; }	// Returns line number.
	int nargs(void) { return numargs; }	// Returns number of arguments.
	String keyword(void);	// Returns keyword.
	String strarg(int);	// Returns argument as String.
	int    intarg(int);	// Returns argument as integer.
	float  fltarg(int);	// Returns argument as float.
	bool kequal(const String&);	// Does keyword equal argument?
	bool kequal(const String&,const String&);
	bool kbegin(const String&);	// Does keyword begin with argument?
	bool kbegin(const String&,const String&);
	int knum1(void);	// Returns 1st number in keyword.
	int knum2(void);	// Returns 2nd number in keyword.
	int knum3(void);	// Returns 3nd number in keyword.
	};

#endif // _LINE_H
