// rotator.h	v1.3	31. March 2006	by eddy

/*  lego -- this program generates images of LEGO(R)-like models.

    		Copyright (C) 1998 - 2008 Edmund Nussbaum.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that you will have a lot of 
    fun when using it, but WITHOUT ANY WARRANTY; without even the implied 
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See 
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Please report your experiences, suggestions or whatever related
    to this program to: 
    
    sibylle.eddy @ t-online.de                   
    en @ mpifr-bonn.mpg.de 

    or send mail to:
    Edmund Nussbaum, Richard-Wagner-Str. 59, 53115 Bonn, Germany 
*/

#ifndef _ROTATOR_H
#define _ROTATOR_H

#include "global.h"
#include "vector.h"

class rotator
	{
	private:
	int skipflag;
	double a1,a2,a3,b1,b2,b3,c1,c2,c3,d1,d2,d3;
	vector rorg;
	public:
	rotator(void);
	rotator(const matrix&);
	rotator(const vector& org,const vector& siz,dir d);
	~rotator(void) {}
	const vector rotorg(const vector&) const;	// Rotate absolute vectors.
	const vector rotsiz(const vector&) const;	// Rotate relative vectors.
	};
	
const rotator NOROT;

#endif // _ROTATOR_H                                                                                                                
