// vector.h	v1.3	31. March 2006	by eddy

/*  lego -- this program generates images of LEGO(R)-like models.

    		Copyright (C) 1998 - 2008 Edmund Nussbaum.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that you will have a lot of 
    fun when using it, but WITHOUT ANY WARRANTY; without even the implied 
    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See 
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Please report your experiences, suggestions or whatever related
    to this program to: 

    sibylle.eddy @ t-online.de                      
    en @ mpifr-bonn.mpg.de 

    or send mail to:
    Edmund Nussbaum, Richard-Wagner-Str. 59, 53115 Bonn, Germany 
*/

#ifndef _VECTOR_H
#define _VECTOR_H

struct matrix
	{
	double a1,a2,a3,b1,b2,b3,c1,c2,c3,d1,d2,d3;
	};

class vector
	{
	private:
	double v_x,v_y,v_z;
	public:
	vector(void);					// Null vector.
	vector(double,double,double);	// Initialized vector.
	~vector(void) { }
	double x(void) const { return v_x; }	// Get x
	double y(void) const { return v_y; }	// Get y
	double z(void) const { return v_z; }	// Get z
//	void set_x(double);		// Set x
//	void set_y(double);		// Set y
//	void set_z(double);		// Set z
	double absvalue(void) const;
	double operator * (const vector&) const;	// Skalarproduct
//	double distance(const vector&) const;
	const vector unit(void) const;
	const vector product(const vector&) const;	// Vectorproduct
	const vector operator + (const vector&) const;
	vector& operator += (const vector&);
	const vector operator - (const vector&) const;
	vector& operator -= (const vector&);
	const vector operator * (double) const;
	vector& operator *= (double);
	const vector operator - (void);
	};
	
const vector operator * (double,const vector&);
	
const vector NULLVEC(0,0,0);
const vector XUNIT(1,0,0);
const vector YUNIT(0,1,0);
const vector ZUNIT(0,0,1);

#endif // _VECTOR_H                                                                                                                
